#include "Axes_2D.h"

#include <QPainter>
#include <QStyleOptionGraphicsItem>
#include <QWidget>
#include <QGraphicsSimpleTextItem>
#include <QString>
#include <math.h>
#include <dolfin/common/constants.h>
#include <QDebug>

//----------------------------------------------------------
Axes_2D::Axes_2D(double min_x, double max_x, double min_y, double max_y)
//----------------------------------------------------------
  : lower_x(min_x, min_y), upper_x(max_x, min_y), 
    lower_y(min_x, min_y), upper_y(min_x, max_y), arrowSize(10)
{
  //qDebug() << "min x = " << min_x << ", max x = " << max_x;
  //qDebug() << "min y = " << min_y << ", max y = " << max_y;

  QGraphicsLineItem* x_axis = new QGraphicsLineItem(QLineF(lower_x, upper_x), this);
  QGraphicsLineItem* y_axis = new QGraphicsLineItem(QLineF(lower_y, upper_y), this);

  double scale_factor = .05;

  QFont font("helvetica", -1);
  QGraphicsSimpleTextItem* lower_x_label = new QGraphicsSimpleTextItem(QString::number(lower_x.x()), this);
  lower_x_label->setFont(font);
  lower_x_label->setTransform(QTransform::fromScale ( scale_factor, -1*scale_factor));
  lower_x_label->setPos(lower_x);// - QPoint(lower_x_label->boundingRect().width()*scale_factor,
                                 //        -1*lower_x_label->boundingRect().height()*scale_factor));

  QGraphicsSimpleTextItem* upper_x_label = new QGraphicsSimpleTextItem(QString::number(upper_x.x()), this);
  upper_x_label->setFont(font);
  upper_x_label->setTransform(QTransform::fromScale ( scale_factor, -1*scale_factor));
  upper_x_label->setPos(upper_x - QPoint(upper_x_label->boundingRect().width()*scale_factor, 0.0));

  QGraphicsSimpleTextItem* lower_y_label = new QGraphicsSimpleTextItem(QString::number(lower_y.y()), this);
  lower_y_label->setFont(font);
  lower_y_label->setTransform(QTransform::fromScale ( scale_factor, -1*scale_factor));
  lower_y_label->setPos(lower_y - QPoint(lower_y_label->boundingRect().width()*scale_factor,
                                         -1*lower_y_label->boundingRect().height()*scale_factor));

  QGraphicsSimpleTextItem* upper_y_label = new QGraphicsSimpleTextItem(QString::number(upper_y.y()), this);
  upper_y_label->setFont(font);
  upper_y_label->setTransform(QTransform::fromScale ( scale_factor, -1*scale_factor));
  upper_y_label->setPos(upper_y - QPoint(upper_y_label->boundingRect().width()*scale_factor, .0));

  //setFlags(QGraphicsItem::ItemIgnoresTransformations);
}

