#ifndef Gui_COLOR_BUTTON_H                // -*- C++ -*-
#define Gui_COLOR_BUTTON_H

#include <QWidget>
#include <QColor>

namespace Ui {
  class ColorButtonBase;
}

/**
 * 
 *
 * \ingroup gui
 *
 * \author Trond Vidar Stensby
 * \author Benjamin Kehlet
 * \date 2010-03-26
 */

class ColorButton : public QWidget
{
  Q_OBJECT;
  
public:
  /** Uncommented */
  ColorButton( QWidget * parent = 0, Qt::WindowFlags f = 0);
  
  /** Uncommented */
  ~ColorButton();
  
  /** Uncommented */
  void setColor(QRgb color);
  
  /** Uncommented */
  void setColor(QColor color);
  
  /** Uncommented */
  QColor getColor() const;
  
  /** Uncommented */
  const QRgb &getRgb() const;
  
  /** Uncommented */
  void setUseAlpha(bool use_alpha);
  
  /** Uncommented */
  bool getUseAlpha() const;
  
  /** Uncommented */
  void setLabel(const QString label);
  
  /** Uncommented */
  QString getLabel() const;
			  
public slots:
  /** Uncommented */
  void colorButtonPressed();
  
signals:
  /** Uncommented */
  void colorChanged(QRgb value);
  void colorChanged(const QColor value);
  
private:
  
  Ui::ColorButtonBase* ui_;
  
  QRgb color_;
  
  bool use_alpha_;
  
};

#endif // Gui_COLOR_BUTTON_H
