#ifndef DRAW_SETTINGS_DIALOG
#define DRAW_SETTINGS_DIALOG

#include <QDialog>

class ApplicationWindow;
class Viewer;

class QGridLayout;
class QSpinBox;
class QLabel;


/** Defines the dialog viewer setting. 
 *  Let the user set background color, and 
 *  ambient, specular and diffuse light colors.
 *  Most of it is taken from the "global settings"
 *  tab of the Toolbox in earlier versions of Meshbuilder.
 *
 *  \author Benjamin Kehlet
 *  \since 2010-04-07
 *  \date  2011-01-28
 */
class DrawSettingsDialog : public QDialog {
  Q_OBJECT

 public:
  DrawSettingsDialog(Viewer* viewer, ApplicationWindow* parent=0);
  ~DrawSettingsDialog();

 private slots :
  void updateSettings();

 private:

  QSpinBox*  vertex_size;
  QSpinBox*  edge_size;

  Viewer* viewer;
};

#endif
