#ifndef Gui_EDGE_2D_H                // -*- C++ -*-
#define Gui_EDGE_2D_H                // -*- C++ -*-

#include "EntityInterface_2D.h"
#include <QPen>
#include <QLineF>

class Vertex_2D;
class QMouseEvent;

/** Represents the edges to be drawn on a Viewer_2D
 *  \author Benjamin Kehlet
 *  \date 2011-02-20
 *  \since 2010-03-16
 */

class Edge_2D : public EntityInterface_2D
{
 public :
  Edge_2D(double x1, double y1, double x2, double y2, uint id);

  QRectF boundingRect() const;
  QPainterPath shape() const;
  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

  void setMeshFunctionValue(uint value, QColor& c);
  void updateBoundaryIndicatorColor();

 private:
  QLineF line;
  qreal size;

  QPen normal_pen;
  QPen hovered_pen;

};

#endif
