#ifndef Gui_EntityInterface_h_Included             // -*- C++ -*-
#define Gui_EntityInterface_h_Included   

#include <QGraphicsItem>

/**
 * Common interface to all entities in 2D viewer
 *
 * \author Benjamin Kehlet
 * \since 2011-02-20
 * \date  2011-02-20
 *
 */

class EntityInterface_2D : public QGraphicsItem
{
 public:
  EntityInterface_2D(uint id)    
    : id(id), hovered(false), color(Qt::black){}

  QRectF boundingRect() const=0;
  QPainterPath shape() const=0;
  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)=0;

  // update the color from the mesh
  virtual void updateBoundaryIndicatorColor()=0;

  // set the color and update the mesh
  virtual void setMeshFunctionValue(uint value, QColor& c) =0;
  void setHovered(bool enable){ prepareGeometryChange(); hovered=enable; }
  uint get_id() const { return id;} 

 protected:
  uint id;
  uint value;
  bool hovered;
  QColor color;

};


#endif
