#ifndef gui_FLOAT_SLIDER_H                // -*- C++ -*-
#define gui_FLOAT_SLIDER_H

#include <QWidget>

namespace Ui{
  class FloatSliderBase;
}

/**
 * 
 *
 * \ingroup gui
 *
 * @author Trond Vidar Stensby
 */

class FloatSlider : public QWidget
{
  Q_OBJECT;

public:
  /** Uncommented */
  FloatSlider(QWidget * parent = 0, Qt::WindowFlags f = 0);
  
  /** Uncommented */
  ~FloatSlider();
  
  /** Uncommented */
  double getValue() const;
  
  /** Uncommented */
  void setCurrentValue(double v);
				
public slots:
  
  /** Uncommented */
  double getMinValue() const;
  
  /** Uncommented */
  void  setMinValue(double v);
  
  /** Uncommented */
  double getMaxValue() const;
  
  /** Uncommented */
  void  setMaxValue(double v);
  
  /** Uncommented */
  double getGranul() const;
  
  /** Uncommented */
  void setGranul(double g);
  
  /** Uncommented */
  void setLabel(const QString label);
  
  /** Uncommented */
  QString getLabel() const;
  
  /** Uncommented */
  void sliderValueChanged(int v);
  
  /** Uncommented */
  void textChanged();
  
signals:
  /** Uncommented */
  void valueChanged(double value);
  
protected:
  /** Uncommented */
  void updateSliderRange();
  
  /** Uncommented */
  void updateWidgets();
  
private:
  
  Ui::FloatSliderBase* ui_;

  
  double min_value_;
  double max_value_;
  double granularity_;
  double value_;
  int no_slider_steps_;    
  int slider_value_;
  QString line_edit_value_;
  
};

#endif // gui_FLOAT_SLIDER_H
