#include <gui/FloatSlider.h>

#include <gui/Viewer.h>
#include <gui/MaterialSettings.h>

#include <scenegraph/OsgDrawableObject.h>

#include <iostream>

//----------------------------------------------------------
MaterialSettings::MaterialSettings(Viewer* viewer)
  : viewer(viewer)
//----------------------------------------------------------
{
  std::cerr << "MaterialSettings: Viewer(" << viewer << ")" << std::endl;
}

//----------------------------------------------------------
MaterialSettings::~MaterialSettings()
//----------------------------------------------------------
{
}
//----------------------------------------------------------
void MaterialSettings::materialDiffuseChanged(double v)
//----------------------------------------------------------
{
  currState().setDiffuseIntensity(v);
  viewer->requestRedraw();
}

//----------------------------------------------------------
void MaterialSettings::materialAmbientChanged(double v)
//----------------------------------------------------------
{
  currState().setAmbientIntensity(v);
  viewer->requestRedraw();
}

//----------------------------------------------------------
void MaterialSettings::materialEmissionChanged(double v)
//----------------------------------------------------------
{
  currState().setEmissionIntensity(v);
  viewer->requestRedraw();
}

//----------------------------------------------------------
void MaterialSettings::materialSpecularChanged(double v)
//----------------------------------------------------------
{
  currState().setSpecularIntensity(v);
  viewer->requestRedraw();
}

//----------------------------------------------------------
void MaterialSettings::materialShininessChanged(double v)
//----------------------------------------------------------
{
  currState().setShininess(v);
  viewer->requestRedraw();
}
//----------------------------------------------------------
SimResState& MaterialSettings::currState()
//----------------------------------------------------------
{
  return *(viewer->getCurrentState());
}
