#ifndef Gui_MATERIAL_SETTINGS_H                // -*- C++ -*-
#define Gui_MATERIAL_SETTINGS_H

#include <QObject>

class Viewer;
class SimResState;

/**
 * 
 *
 * \ingroup gui
 *
 * \author Trond Vidar Stensby
 * \author Benjamin Kehlet
 * \date 2010-03-29
 */

class MaterialSettings : public QObject
{
  Q_OBJECT;
  
public:
  MaterialSettings(Viewer* viewer);
  ~MaterialSettings();


public slots:
  
  /** Uncommented */
  void materialDiffuseChanged(double v);
      
  /** Uncommented */
  void materialAmbientChanged(double v);
      
  /** Uncommented */
  void materialEmissionChanged(double v);
      
  /** Uncommented */
  void materialSpecularChanged(double v);
      
  /** Uncommented */
  void materialShininessChanged(double v);
      
  /** Uncommented */
  //void currentSimResStateChanged(int id);
      
private:
  SimResState& currState();
  Viewer* viewer;
};


#endif // Gui_MATERIAL_SETTINGS_H
