#ifndef MESH_FUNCTIONS_TOOLBAR_H
#define MESH_FUNCTIONS_TOOLBAR_H

#include <QToolBar>
#include <gui/DolfinObject.h>

class QButtonGroup;
class QPushButton;
class QSpinBox;
class QCheckBox;
class QLabel;
class QComboBox;
class ColorMap;
class ApplicationWindow;
class Context;
class OsgDolfinObject;
class DolfinEventHandler;
class Viewer;

/** 
 *  The toolbar for marking meshfunctions.
 *  TODO: Replace the button text with some nice looking
 *  icons.
 *  
 *  \author Benjamin Kehlet
 *  \date  2010-03-29
 *  \since 2011-02-17
 */
class MeshFunctionsToolbar : public QToolBar {
  Q_OBJECT

 public:
  MeshFunctionsToolbar(Context &context);

  enum ENTITY_MODE{VERTEX, EDGE, FACE};

  ENTITY_MODE getEntityMode();
  DolfinObject::SELECT_MODE getSelectMode();
  int getFunctionValue();

 private:
  QPushButton* on_off_button;

  QSpinBox* function_value;

  QButtonGroup* button_group;
  QPushButton*  vertex;
  QPushButton*  edge;
  QPushButton*  face;

  QPushButton* color_map_button;
  ColorMap*    color_map;

  QComboBox* markMethod;

  Context &context;

 private slots:
  void enable(bool enable);
  void show_color_map(bool show);
  void close_color_map();

 private:
  //DolfinEventHandler* current_event_handler;
};

#endif
