#ifndef Gui_SIM_RES_SETTINGS_H                // -*- C++ -*-
#define Gui_SIM_RES_SETTINGS_H

#include <QObject>
#include <gui/Context.h>
#include <util/SimResState.h>


/**
 * 
 *
 * \ingroup gui
 *
 * \author Trond Vidar Stensby
 * \author Benjamin Kehlet
 * \date 2010-03-29
 */

class SimResSettings : public QObject
{
  Q_OBJECT;
  
public:
  SimResSettings(Viewer* viewer);
  ~SimResSettings();  
  
  /** Uncommented */
  void setActiveSimResState(SimResState* state);

  SimResState& currState();                                               
					       
public slots:
  
  void simresBaseColorChanged(QRgb value);
  void simresBackColorChanged(QRgb value);
  
  void simresWireframeColorChanged(QRgb value);
  void simresHighlightColorChanged(QRgb value);

  void simresTransparancyChanged(double v);
  
  void simresRenderModeChanged(int button);

  void simresSortModeSelected(const QString&);
  void simresCullModeChanged(int mode);
  void simresTwoSidedLightingChanged(bool on);
      
  void simresDepthSortButtonPressed();
      
  void pointSizeChanged(double v);
      
  void lineWidthChanged(double v);

  void contoursChanged(bool onoff);

  void contourNbChanged(int nb);

  void showBoundingSphereChanged(bool checked);
  void showTriangleNormalsChanged(bool checked);
  void showHighlightChanged(bool checked);
  void showAxesChanged(bool checked);
  void showPlaneChanged(bool checked);

private:


  Viewer* viewer;
};


#endif // Gui_SIM_RES_SETTINGS_H
