#ifndef TRANSFORMATIONS_DIALOG_H
#define TRANSFORMATIONS_DIALOG_H

#include <QDialog>

class ApplicationWindow;
class QTabWidget;
class QWidget;
class FloatSlider;
class QVBoxLayout;
class QGroupBox;
class QCheckBox;
class QPushButton;
class Viewer;

/** Defines the dialog 
 *
 *  \author Benjamin Kehlet
 *  \since 2010-03-28
 *  \date  2010-03-28
 */

class TransformationsDialog : public QDialog {
  Q_OBJECT

public:
  TransformationsDialog(Viewer* viewer, ApplicationWindow* parent=0);

 private:
  QTabWidget* tabs;

  //Translate page
  QWidget*     translate_page;
  QVBoxLayout* translate_layout;
  FloatSlider* trans_x_slider;
  FloatSlider* trans_y_slider;
  FloatSlider* trans_z_slider;

  //Rotate page
  QWidget*     rotate_page;
  QVBoxLayout* rotate_layout;

  QGroupBox*   axis_angle_group;
  QVBoxLayout* axis_angle_layout;
  FloatSlider* rot_x_slider;
  FloatSlider* rot_y_slider;
  FloatSlider* rot_z_slider;
  FloatSlider* rot_angle_slider;

  QGroupBox*   euler_group;
  QVBoxLayout* euler_layout;
  FloatSlider* euler_x_slider;
  FloatSlider* euler_y_slider;
  FloatSlider* euler_z_slider;

  // Scale page
  QWidget*     scale_page;
  QVBoxLayout* scale_layout;
  QCheckBox*   uniform_scale_chk;
  FloatSlider* scale_all_slider;
  FloatSlider* scale_x_slider;
  FloatSlider* scale_y_slider;
  FloatSlider* scale_z_slider;

  QPushButton* close_button;

  Viewer* viewer;
    
};

#endif
