#ifndef Gui_VERTEX_2D_H                // -*- C++ -*-
#define Gui_VERTEX_2D_H                // -*- C++ -*-

#include "EntityInterface_2D.h"
#include <QGraphicsItem>
#include <QPen>

class QGraphicsSceneMouseEvent;

/** Represents the vertices to be drawn on a Viewer_2D
 *  \author Benjamin Kehlet
 *  \date 2010-03-16
 *  \since 2011-02-20
 */
class Vertex_2D : public EntityInterface_2D
{
 public :
  Vertex_2D(double x, double y, uint id);

  void updateBoundaryIndicatorColor();
  void setMeshFunctionValue(uint value, QColor& c);

  QRectF boundingRect() const;
  QPainterPath shape() const;
  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

 private :
  double size;

  QPen p;
  QBrush b;
};


#endif
