#ifndef Gui_ViewerInterface_h_Included             // -*- C++ -*-
#define Gui_ViewerInterface_h_Included   


class QMenuBar;
class QAction;
class QWidget;
class DolfinObject;

/**
 * NewViewer
 * Common interface to both 2D and 3D viewer
 *
 * \author Benjamin Kehlet
 * \since 2011-01-28
 * \date  2011-01-28
 *
 */

class ViewerInterface
{
 public:
  // NOTE: The enable argument is superfluous since the viewer will
  // have to access the meshfunctions toolbar anyway. Maybe send a
  // pointer to the toolbar or no argument at all.
  virtual void enableMeshFunctions(bool enable)=0;

  // Boundary indicator interface
  virtual void setVertexBoundaryIndicator(uint id, int value)=0;
  virtual void setEdgeBoundaryIndicator  (uint id, int value)=0;
  virtual void setFaceBoundaryIndicator  (uint id, int value)=0;

  // Read mesh function value from DolfinObject and update viewer
  virtual void updateBoundaryIndicatorColors()=0;

  virtual void viewCenter()=0;

  // Not shure if this should be put here.
  virtual void saveImage(QString filename)=0;
  virtual void undo()=0;

  // return the the items of the viewer specific menu
  virtual QList<QAction*> getViewerMenu()=0;

  virtual QWidget* get_widget()=0;
  virtual DolfinObject& get_mesh()=0;

};


#endif
