#include "VisualizationDialog_2D.h"
#include <gui/ApplicationWindow.h>
#include <gui/Viewer_2D.h>

#include <QCheckBox>
#include <QPushButton>
//----------------------------------------------------------
VisualizationDialog_2D::VisualizationDialog_2D(Viewer_2D* viewer, 
                                               ApplicationWindow* parent)
  : QDialog(parent), viewer(viewer)
//----------------------------------------------------------
{

  QVBoxLayout* layout = new QVBoxLayout(this);
  layout->setSpacing(6);
  layout->setMargin(6);

  this->setLayout(layout);

  // Show axes button
  showAxes = new QCheckBox("Show axes", this);
  showAxes->setChecked(false);
  layout->addWidget(showAxes);


  // Close button
  QPushButton* close_button = new QPushButton("Close");
  layout->addWidget(close_button);


  //Setup connections
  connect(showAxes, SIGNAL(toggled(bool)),
          viewer, SLOT(showAxesChanged(bool)));

  connect(close_button, SIGNAL(clicked()),
          this, SLOT(accept()));
  
}
