#ifndef OsgQt_AdapterWidget_h_Included             // -*- C++ -*-
#define OsgQt_AdapterWidget_h_Included   

#include <osgViewer/Viewer>

#include <QtGui/QKeyEvent>
#include <QtGui/QMouseEvent>
#include <QtOpenGL/QGLWidget>

using Qt::WindowFlags;

/// AdapterWidget -- QT to Osg event adaptor. 
/**
 * QT to Osg event adaptor. 
 *
 * Based on Osg example program.
 * \ingroup KbtOsg
 *
 */

class AdapterWidget : public QGLWidget
{
  Q_OBJECT;
  
public:
  AdapterWidget(QWidget* parent = 0, const char* name = 0,
		const QGLWidget* shareWidget = 0, WindowFlags f = 0);
  
  virtual ~AdapterWidget();
  
  osgViewer::GraphicsWindow* getGraphicsWindow() { return _gw.get(); }
  const osgViewer::GraphicsWindow* getGraphicsWindow() const { return _gw.get(); }
  
protected:
  
  virtual void processAdaptedEvents() = 0;
  
  //   void init();
  void debugCurrentEventState();
  
  virtual void resizeGL(int width, int height);
  virtual void keyPressEvent(QKeyEvent* event);
  virtual void keyReleaseEvent(QKeyEvent* event);
  virtual void mousePressEvent(QMouseEvent* event);
  virtual void mouseReleaseEvent(QMouseEvent* event);
  virtual void mouseMoveEvent(QMouseEvent* event);
  virtual void wheelEvent(QWheelEvent* event);
  
  int getButtonAndProcessModifiers(QMouseEvent* event);
  
  osg::ref_ptr<osgViewer::GraphicsWindowEmbedded> _gw;
  
  //friend class GraphicsScene;
};

  
#endif // OsgQt_AdapterWidget_h_Included
