#ifndef Util_QtUtil_h_Included          // -*- C++ -*-
#define Util_QtUtil_h_Included

#include <osg/Vec3>
#include <osg/Vec4>

#include <QTextStream>
#include <QStringList>
#include <QDateTime>
#include <QColor>

class QObject;
class QString;

/**
 * 
 *
 * \ingroup Util
 *
 * @author Trond Vidar Stensby
 */

class QtUtil
{
public:
  
  /** Uncommented */
  static void recursiveBlockSignals(QObject* o, bool b);

  /** Converts a Qt color to an osg color */
  static osg::Vec4 qtToOsg(const QColor qcol);

  /** Converts an osg color to a Qt color */
  static QColor osgToQt(const osg::Vec4 col);

  /** Uncommented */
  static QString toStr(osg::Vec3 v);
      
  /** Uncommented */
  static QString toStr(osg::Vec4 v);
      
  /** Uncommented */
  static QString toStr(osg::Vec3 v, double w);
      
  /** Encode symbols conflicting with richtext format */
  static QString toStr(QString txt);
      
  /** Encode table in RichText format */
  static void beginTable(QTextStream &os, const QString &entry, const QString &description);
      
  /** Encode table in RichText format */
  static void newRow(QTextStream &os, const QString &entry, const QString &description);
      
  /** Encode table in RichText format */
  static void endTable(QTextStream &os);
      
  /** Returns all files in a directory newer that the given date */
  static QStringList findNewFiles(const QString &dir_path, const QDateTime &date);
      
};

#endif // Util_QtUtil_h_Included
